
int LEVEL1_AMT = 12;
int LEVEL2_AMT = 5;

int fw = 800;
int fh = 600;
final int VERT = -1;
final int HORZ = 1;

ArrayList rects = new ArrayList();

void setup()
{  
  size(fw, fh);
  frame.setResizable(true);
  textFont(loadFont("ArialNarrow-BoldItalic-48.vlw"), 48); 
  
  // *** set up top level of data
  
  //ArrayList level1 = makeRandomRects(1, LEVEL1_AMT);
  ArrayList level1 = makeDeweyRects();
  
  sortRectsByCount(level1, -1);
  //Collections.shuffle(level1);

  int level1Count = getTotalCount(level1);
  
  int orientation = VERT;
  if (fw < fh)
  {
    orientation = HORZ;
  }
  
  // *** call treemap method recursively
  squarify(level1, orientation, Float.POSITIVE_INFINITY, 0f, 0f, (float)fw, (float)fh, (float)fw, (float)fh, (fw * fh) / level1Count, 0);


  // *** set up second level of data (using random data)
  
  ArrayList level2 = new ArrayList();

  for (int i = 0; i < level1.size(); i++)
  {
    Rect r = (Rect) level1.get(i);
    ArrayList nrs = makeRandomRects(2, LEVEL2_AMT);  
    //sortRectsByCount(nrs, -1);

    int level2Count = getTotalCount(nrs);

    int orientation2 = VERT;
    if (r.w <= r.h)
    {
      orientation2 = HORZ;
    }
    println("\n\nlevel2, rect" + i);
    
    // *** call treemap method recursively
    squarify(nrs, orientation2, Float.POSITIVE_INFINITY, r.x, r.y, r.w, r.h, r.w, r.h, (r.w * r.h) / level2Count, 0);
    level2.addAll(nrs);
  }

  rects.addAll(level1);
  rects.addAll(level2);
}

public int getTotalCount(ArrayList rs)
{
  int totalCount = 0;
  for (int i = 0; i < rs.size(); i++)
  {
    Rect rect = (Rect) rs.get(i);
    totalCount += rect.count; 
  }
  return totalCount;
}

public ArrayList makeRandomRects(int level, int howMany)
{
  color strokeColor = color(255,255,255);
  if (level == 1)
  {
    strokeColor = color(255,0,0);
  }
  else if (level == 2)
  {
    strokeColor = color(255,255,255);
  }

  ArrayList rs = new ArrayList();
  for (int i = 0; i < howMany; i++)
  {
    //rs.add(new Rect("000", (int)random(1,50), color(random(0,255), random(0,255), random(0,255), 100)));
    rs.add( new Rect(level, "000", (int)random(10,50), color(255,255,255,0), strokeColor));
  }

  return rs;
}

color randomColor(int alpha)
{
  return color(random(100,200), random(100,200), random(100,200), alpha);
}

public ArrayList makeDeweyRects()
{
  ArrayList rs = new ArrayList();
   color strokeColor = color(255);
   int alpha = 150;
   rs.add(new Rect(1,"000", 45, randomColor(alpha), strokeColor));
   rs.add(new Rect(1,"100", 10, randomColor(alpha), strokeColor));
   rs.add(new Rect(1,"200", 10, randomColor(alpha), strokeColor));
   rs.add(new Rect(1,"300", 22, randomColor(alpha), strokeColor));
   rs.add(new Rect(1,"400", 45, randomColor(alpha), strokeColor));
   rs.add(new Rect(1,"500", 12, randomColor(alpha), strokeColor));
   rs.add(new Rect(1,"600", 50, randomColor(alpha), strokeColor));
   rs.add(new Rect(1,"700", 100, randomColor(alpha), strokeColor));
   rs.add(new Rect(1,"800", 11, randomColor(alpha), strokeColor));
   rs.add(new Rect(1,"900", 80, randomColor(alpha), strokeColor));
  return rs;
}  


void squarify(ArrayList rs, int orientation, float currentAspectRatio, 
  float x, float y, float w, float h, float fullw, float fullh, float scalar, int currentRectIdx)
{
  //println("in squarify : orientation = " + orientation + ", x/y/w/h = " + x + "/" + y + "/" + w + "/" + h + " fullw/fullh = " + fullw + "/" + fullh); 
  int currentCount = 0;
  int startIdx = currentRectIdx;
  int endIdx = currentRectIdx;
  float uw = 0f;
  float uh = 0f;
  int tempCount = 0;

  if (orientation == VERT)
  {
    //println("\t\tin VERT...");
    while (endIdx < rs.size() )
    {
      Rect nextRect = (Rect) rs.get(currentRectIdx); 
      tempCount += nextRect.count;

      //println("\t\there... currentRectIdx = " + currentRectIdx);
      float tw = (tempCount * scalar) / h;
      float th = h;

      if (max(tw/th, th/tw) <= currentAspectRatio || endIdx == rs.size() - 1)
      {
        endIdx++;
        currentCount = tempCount;
        currentRectIdx++;
        uw = tw;
        uh = th; 
        currentAspectRatio = max(tw/th, th/tw); 
      }
      else
      {
        break;
      }   

    }

    float sy = y;
    for (int i = startIdx; i <= endIdx - 1; i++)
    {
      if (i >= rs.size())
      {
        break;
      }
      Rect cr = (Rect) rs.get(i);

      cr.x = x;
      cr.y = sy;
      cr.w = uw;
      cr.h = uh * ((float)cr.count / (float)currentCount);
      cr.orientation = VERT;
      println(cr);

      sy += cr.h;
    } 

    if (endIdx < rs.size())
    {
      squarify(rs, HORZ, Float.POSITIVE_INFINITY, x + uw, y, fullw - uw, h, fullw - uw, fullh, scalar, endIdx);  
    }
    return;
  }


  else //(orientation == HORZ)
  {
    //println("\t\tin HORZ...");
    while (endIdx < rs.size())
    {
      Rect nextRect = (Rect) rs.get(currentRectIdx); 
      tempCount += nextRect.count;

      //println("\t\there... currentRectIdx = " + currentRectIdx);
      float th = (tempCount * scalar) / w;
      float tw = w;

      if (max(tw/th, th/tw) <= currentAspectRatio || endIdx == rs.size() - 1)
      {
        endIdx++;
        currentCount = tempCount;
        currentRectIdx++;
        uw = tw;
        uh = th; 
        currentAspectRatio = max(tw/th, th/tw); 
      }
      else
      {
        break;
      }   

    }

    float sx = x;
    for (int i = startIdx; i <= endIdx - 1; i++)
    {
      if (i >= rs.size())
      {
        break;
      }
      Rect cr = (Rect) rs.get(i);

      float winc = uw * ((float)cr.count / (float)currentCount); 
      cr.x = sx;
      cr.y = y;
      cr.h = uh;
      cr.w = winc;
      cr.orientation = HORZ;
      println(cr);

      sx += winc;
    }

    if (endIdx < rs.size())
    {
      if (endIdx == rs.size() - 1)
      {
         return;
      }
      else
      {  
        squarify(rs, VERT, Float.POSITIVE_INFINITY, x, y + uh, w, fullh - uh, fullw,  (fullh - uh), scalar, endIdx);
      }
    }
    return;
  }
}

void draw()
{
  background(0);
  for (int i = 0; i < rects.size(); i++)
  {
    Rect r = (Rect) rects.get(i);

    r.draw();
  }
}


//sort a list of Map.Entrys by their value. This assumes that the value is an Integer! 
//order = 1 for Ascending, order = -1 for descending.  
void sortRectsByCount(ArrayList entryList, final int order)
{
  Collections.sort(entryList, new Comparator()
  {
    public int compare(Object o1, Object o2)
    {
      Rect r1 = (Rect) o1;
      Rect r2 = (Rect) o2;

      return (r1.count - r2.count) * order;
    }
  }
  );
}




